import { CommonModule } from '@angular/common';
import { WjGridModule } from '@grapecity/wijmo.angular2.grid';
import { WjGridDetailModule } from '@grapecity/wijmo.angular2.grid.detail';
import { WjGridFilterModule } from '@grapecity/wijmo.angular2.grid.filter';
import { WjInputModule } from '@grapecity/wijmo.angular2.input';
import { createHostFactory, SpectatorHost } from '@ngneat/spectator/jest';

import { GridComponent } from './grid.component'

describe('FlexGrid Component Integrated Tests', () => {

    let spectator: SpectatorHost<GridComponent>;

    const minimumGridTemplate =
        `<app-grid>
        </app-grid>`;

    const createComponent = createHostFactory({
        component: GridComponent,
        declarations: [
        ],
        imports: [
            CommonModule,
            WjInputModule,
            WjGridModule,
            WjGridDetailModule,
            WjGridFilterModule,
        ],
        providers: [
        ],
        template: minimumGridTemplate
    });

    it('should create the component', () => {
        spectator = createComponent();

        expect(spectator.component).toBeTruthy();
        const newData = [{
            id: 1000,
            country: 'US',
            sales: Math.random() * 10000,
            expenses: Math.random() * 5000
        }]

        spectator.setInput({
            data: newData
        });
        spectator.fixture.detectChanges();

        expect(spectator.component.data).toBe(newData);
    });
});
